#ifdef _WIN32
#include <SDL.h>
#elif __linux
#include <SDL/SDL.h>
#endif

#include <cstdio>
#include <cstring>

#ifndef _WIN32
#define stricmp strcasecmp
#define strnicmp strncasecmp
#endif

#include "conquests/game.h"

int main(int argc, char *argv[]) {
	/*{
		Game::doDocs();
		return 0;
	}*/
	/*{
		Game::doTests(MainGamestate::TEST_ALL, true);
		//Game::doTests(MainGamestate::TEST_SETTLER_BUILDCITY_15);
		//Game::doTests(MainGamestate::TEST_SETTLER_BUILDCITY_16);
		//Game::doTests(MainGamestate::TEST_MAKE_CONTACT_1);
		//Game::doTests(MainGamestate::TEST_AIR_BOMB_0);
		//Game::doTests(MainGamestate::TEST_FOW_0);
		//Game::doTests(MainGamestate::TEST_FOW_3);
		//Game::doTests(MainGamestate::TEST_FOW_4);
		//Game::doTests(MainGamestate::TEST_CITYBUILD_17);
		//Game::doTests(MainGamestate::TEST_AIPERF_13);
		//Game::doTests(MainGamestate::TEST_DISTANCES_0);
		//Game::doTests(MainGamestate::TEST_DISTANCES_1);
		//Game::doTests(MainGamestate::);
		return 0;
	}*/
	if( argc <= 1 ) {
		Game::doGame();
	}
	else {
		if( stricmp(argv[1], "test") == 0 ) {
			bool quiet = false;
			if( argc >= 3 && stricmp(argv[2], "quiet") == 0 ) {
				quiet = true;
			}
			Game::doTests(MainGamestate::TEST_ALL, quiet);
		}
		else {
			printf("Unknown option: %s\n", argv[0]);
		}
	}
	return 0;
}
