print("generate_buildables.lua enter")

-- Improvements

-- N.B., some effects of Improvements are hardcoded.

-- Arguments: Name, cost, required technology, ai weighting

-- ancient

improvement = conquests_addNewImprovement("Barracks", 40, "Military Tactics", 30)
	-- TODO: avoid hardcoded 25 turns
conquests_buildableSetInfo(improvement, "The Barracks improvement will automatically produce one military unit of footsoldiers every 25 turns.")

improvement = conquests_addNewImprovement("Farmland", 20, "Agriculture", 0)
	-- AI weight 0, handled with specific code
	-- TODO: avoid harded size 3
conquests_buildableSetInfo(improvement, "Farmland is required for a city to grow beyond size 3.")

improvement = conquests_addNewImprovement("Aqueduct", 60, "Construction", 0)
	-- AI weight 0, handled with specific code
	-- TODO: avoid harded size 6
conquests_buildableSetInfo(improvement, "An Aqueduct is required for a city to grow beyond size 6.")
conquests_buildableSetRequiresImprovement(improvement, "Farmland")

improvement = conquests_addNewImprovement("Fort", 40, "", 10)
	improvement_fort = improvement
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Fort increases the defence of your units in the city by 25%, unless the attacker has discovered Gunpowder.")
	conquests_buildableSetObsoletedBy(improvement, "Gunpowder")

improvement = conquests_addNewImprovement("Harbour", 40, "Sailing", 15)
	improvement_harbour = improvement
	conquests_buildableSetInfo(improvement, "A Harbour allows exploration and travel by sea.")
	conquests_improvementSetRequiresCoastal(improvement, true)
	conquests_improvementSetTravelRange(improvement, 5, false)
	conquests_improvementSetPowerPerTurn(improvement, 1)

improvement = conquests_addNewImprovement("Library", 40, "Writing", 5)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Library increases the rate of scientific research in the city by 50%.")
	conquests_improvementSetPowerPerTurn(improvement, 1)
	conquests_improvementSetAIHint(improvement, IMPROVEMENT_AIHINT_RESEARCH)

improvement = conquests_addNewImprovement("Mine", 20, "Iron Working", 40)

improvement = conquests_addNewImprovement("Temple", 20, "Masonry", 0)
	improvement_temple = improvement
	conquests_buildableSetObsoletedBy(improvement, "Scientific Method")
	conquests_improvementSetPowerPerTurn(improvement, 1)

improvement = conquests_addNewImprovement("Walls", 80, "Masonry", 15)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "City Walls increase the defence of your units in the city by 50%, unless the attacker has discovered Gunpowder. They also protect against population losses when your city is attacked, for cities of size less than or equal to size 6.\n\nReplaces Fort.")
	conquests_buildableSetObsoletedBy(improvement, "Gunpowder")
	conquests_buildableSetReplacedBy(improvement_fort, improvement)

improvement = conquests_addNewImprovement("Market", 40, "Trade", 15)
	conquests_improvementSetPowerPerTurn(improvement, 2)

-- medieval

improvement = conquests_addNewImprovement("Armourer", 40, "Medieval Arms", 40)
	improvement_armourer = improvement
	conquests_buildableSetRequiresImprovement(improvement, "Mine")
	conquests_buildableSetObsoletedBy(improvement, "Firearms")

improvement = conquests_addNewImprovement("Castle", 60, "Castles", 20)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Castle increases the defence of your units in the city by 50%, unless the attacker has discovered Gunpowder.")
	conquests_buildableSetObsoletedBy(improvement, "Gunpowder")
	conquests_improvementSetPowerPerTurn(improvement, 1)

improvement = conquests_addNewImprovement("Church", 40, "Feudalism", 0)
	conquests_buildableSetObsoletedBy(improvement, "Scientific Method")
	conquests_improvementSetPowerPerTurn(improvement, 2)
	conquests_buildableSetReplacedBy(improvement_temple, improvement)

improvement = conquests_addNewImprovement("Port", 60, "Navigation", 15)
	conquests_buildableSetInfo(improvement, "A Port allows exploration and travel by sea.")
	conquests_improvementSetRequiresCoastal(improvement, true)
	conquests_improvementSetTravelRange(improvement, 10, false)
	conquests_improvementSetPowerPerTurn(improvement, 2)
	conquests_buildableSetReplacedBy(improvement_harbour, improvement)

improvement = conquests_addNewImprovement("University", 100, "Education", 5)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A University increases the rate of scientific research in the city by 50%")
	conquests_buildableSetRequiresImprovement(improvement, "Library")
	conquests_improvementSetPowerPerTurn(improvement, 1)
	conquests_improvementSetAIHint(improvement, IMPROVEMENT_AIHINT_RESEARCH)

-- industrial

improvement = conquests_addNewImprovement("Coastal Defence", 100, "Steam Power", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Coastal Defence increases the defence bonus against sea attacks to 50%.")
	conquests_improvementSetRequiresCoastal(improvement, true)

improvement = conquests_addNewImprovement("Factory", 400, "Industrial Revolution", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Factory increases the maximum city size, once you have discovered Combustion.")
	conquests_buildableSetRequiresImprovement(improvement, "Mine")
	conquests_buildableSetReplacedBy(improvement_armourer, improvement)

improvement = conquests_addNewImprovement("Hospital", 300, "Medicine", 10)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Hospital increases the rate of city growth.")
	conquests_improvementSetPowerPerTurn(improvement, 3)

improvement = conquests_addNewImprovement("School", 300, "Industrial Revolution", 5)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A School increases the basic rate of scientific research in the city by 2.")
	conquests_improvementSetPowerPerTurn(improvement, 3)
	conquests_improvementSetAIHint(improvement, IMPROVEMENT_AIHINT_RESEARCH)

-- modern

improvement = conquests_addNewImprovement("Airport", 600, "Flight", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "An Airport allows air units to bomb from here, or rebase from or to here, and allows exploration and travel by air.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetTravelRange(improvement, biplane_travel_range_c, true)
	conquests_improvementSetPowerPerTurn(improvement, 5)

improvement = conquests_addNewImprovement("Anti-Air Guns", 800, "Advanced Flight", 15)
	improvement_antiairguns = improvement
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "Can defend against air attacks, defence 4.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetAirDefence(improvement, 4)

improvement = conquests_addNewImprovement("Lab", 500, "Computer", 5)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Lab increases the rate of scientific research in the city by 50%.")
	conquests_buildableSetRequiresImprovement(improvement, "University")
	conquests_improvementSetPowerPerTurn(improvement, 3)
	conquests_improvementSetAIHint(improvement, IMPROVEMENT_AIHINT_RESEARCH)

improvement = conquests_addNewImprovement("Missile Launcher", 800, "Rocketry", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Missile Launcher allows missile units to bomb from here.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetImmuneFromBombing(improvement, true) -- so if a civilization is nuked, they can retaliate

improvement = conquests_addNewImprovement("Radar Tower", 600, "Advanced Flight", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "A Radar Tower increases the visibility around a city.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetAIHint(improvement, IMPROVEMENT_AIHINT_FOW)

improvement = conquests_addNewImprovement("SAM Launcher", 2000, "Rocketry", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "Can defend against air attacks, defence 12.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetAirDefence(improvement, 12)
	conquests_buildableSetReplacedBy(improvement_antiairguns, improvement)

improvement = conquests_addNewImprovement("Bomb Shelter", 1000, "Nuclear Missiles", 30)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "May reduce population deaths from nuclear attacks.")
	conquests_buildableSetRequiresImprovement(improvement, "Factory")
	conquests_improvementSetImmuneFromBombing(improvement, true)

improvement = conquests_addNewImprovement("Spaceport", 2000, "Satellites", 0)
	conquests_buildableSetRequiresImprovement(improvement, "Airport")
	conquests_improvementSetPowerPerTurn(improvement, 10)

improvement = conquests_addNewImprovement("SDI Lasers", 2000, "Space Militarisation", 40)
	-- TODO: avoid hardedcoded text for behaviour
	conquests_buildableSetInfo(improvement, "80% chance of preventing nuclear attacks to this city.")
	conquests_buildableSetRequiresImprovement(improvement, "Spaceport")

--[[
improvement = conquests_addNewImprovement("", 40, "", 15)
	conquests_buildableSetInfo(improvement, "")
	conquests_improvementSet(improvement, )
--]]

-- Unit Templates

-- Note that any new units must have a corresponding image in conquests/data/gfx/, called unit_NAME.png, where
-- NAME is the unit's name.

-- Arguments: Name, cost, required technology, attack, defence, moves

-- special

unit_template = conquests_addNewUnitTemplate("Settlers", 20, "", 0, 0, 1)
	conquests_buildableSetInfo(unit_template, "Settlers may only be built in cities of size 2 or greater.")
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildCity(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)

-- ancient

unit_template = conquests_addNewUnitTemplate("Archers", 15, "Archery", 2, 1, 1)
	unit_template_archers = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)

unit_template = conquests_addNewUnitTemplate("Catapults", 40, "Mathematics", 6, 1, 1)
	unit_template_catapults = unit_template
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

unit_template = conquests_addNewUnitTemplate("Chariots", 40, "The Wheel", 4, 1, 2)
	unit_template_chariots = unit_template
	conquests_unitTemplateSetUpgrade(unit_template, true)

unit_template = conquests_addNewUnitTemplate("Horsemen", 20, "Horse Riding", 2, 1, 2)
	unit_template_horsemen = unit_template

unit_template = conquests_addNewUnitTemplate("Swordsmen", 30, "Iron Working", 3, 2, 1)
	unit_template_swordsmen = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_buildableSetRequiresImprovement(unit_template, "Mine")

unit_template = conquests_addNewUnitTemplate("Peasants", 10, "", 1, 1, 1)
	unit_template_peasants = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)

unit_template = conquests_addNewUnitTemplate("Spearmen", 20, "Bronze Working", 1, 2, 1)
	unit_template_spearmen = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)

-- medieval

unit_template = conquests_addNewUnitTemplate("Knights", 40, "Medieval Arms", 5, 2, 2)
	unit_template_knights = unit_template
	conquests_buildableSetRequiresImprovement(unit_template, "Armourer")
	conquests_buildableSetReplacedBy(unit_template_chariots, unit_template)
	conquests_buildableSetReplacedBy(unit_template_horsemen, unit_template)

unit_template = conquests_addNewUnitTemplate("Men-At-Arms", 30, "Medieval Arms", 3, 3, 1)
	unit_template_men_at_arms = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_buildableSetRequiresImprovement(unit_template, "Armourer")
	conquests_buildableSetReplacedBy(unit_template_swordsmen, unit_template)

unit_template = conquests_addNewUnitTemplate("Pikemen", 25, "Medieval Arms", 1, 3, 1)
	unit_template_pikemen = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)
	conquests_buildableSetReplacedBy(unit_template_spearmen, unit_template)

-- industrial

unit_template = conquests_addNewUnitTemplate("Cannon", 60, "Gunpowder", 8, 1, 1)
	unit_template_cannon = unit_template
	conquests_buildableSetReplacedBy(unit_template_catapults, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

unit_template = conquests_addNewUnitTemplate("Cavalry", 80, "Firearms", 6, 3, 3)
	unit_template_cavalry = unit_template
	conquests_buildableSetReplacedBy(unit_template_knights, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

unit_template = conquests_addNewUnitTemplate("Militia", 20, "Nationalism", 2, 2, 1)
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_buildableSetReplacedBy(unit_template_peasants, unit_template)
	conquests_buildableSetReplacedBy(unit_template_archers, unit_template)

unit_template = conquests_addNewUnitTemplate("Musketeers", 50, "Firearms", 3, 6, 1)
	unit_template_musketeers = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)
	conquests_buildableSetReplacedBy(unit_template_men_at_arms, unit_template)
	conquests_buildableSetReplacedBy(unit_template_pikemen, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

unit_template = conquests_addNewUnitTemplate("Riflemen", 80, "Nationalism", 3, 8, 1)
	unit_template_riflemen = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)
	conquests_buildableSetReplacedBy(unit_template_musketeers, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

-- modern

unit_template = conquests_addNewUnitTemplate("Infantry", 200, "Explosives", 8, 14, 1)
	unit_template_infantry = unit_template
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_unitTemplateSetUpgrade(unit_template, true)
	conquests_buildableSetRequiresImprovement(unit_template, "Factory")
	conquests_buildableSetReplacedBy(unit_template_riflemen, unit_template)
	conquests_buildableSetReplacedBy(unit_template_cannon, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_BREAK)

unit_template = conquests_addNewUnitTemplate("Tanks", 800, "Motorised Warfare", 24, 12, 3)
	unit_template_tanks = unit_template
	conquests_buildableSetRequiresImprovement(unit_template, "Factory")
	conquests_buildableSetReplacedBy(unit_template_cavalry, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_GUNSHOT)

unit_template = conquests_addNewUnitTemplate("Modern Infantry", 800, "Rocketry", 16, 28, 1)
	conquests_unitTemplateSetFoot(unit_template, true)
	conquests_unitTemplateSetCanBuildRoads(unit_template, true)
	conquests_buildableSetRequiresImprovement(unit_template, "Factory")
	conquests_buildableSetReplacedBy(unit_template_infantry, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_GUNSHOT)

unit_template = conquests_addNewUnitTemplate("Modern Tanks", 3200, "Microprocessor", 36, 24, 4)
	conquests_buildableSetRequiresImprovement(unit_template, "Factory")
	conquests_buildableSetReplacedBy(unit_template_tanks, unit_template)
	conquests_unitTemplateSetSoundEffectCombat(unit_template, SOUNDEFFECT_GUNSHOT)

-- air units

unit_template = conquests_addNewUnitTemplate("Biplanes", 100, "Flight", 0, 0, 1)
	unit_template_biplanes = unit_template
	conquests_unitTemplateSetAir(unit_template, 1, 1, biplane_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, biplane_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 10, 40)

unit_template = conquests_addNewUnitTemplate("Fighters", 200, "Advanced Flight", 0, 0, 1)
	unit_template_fighters = unit_template
	conquests_unitTemplateSetAir(unit_template, 0, 8, bombers_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, bombers_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 0, 0)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")
	conquests_buildableSetReplacedBy(unit_template_biplanes, unit_template)

unit_template = conquests_addNewUnitTemplate("Bombers", 400, "Advanced Flight", 0, 0, 1)
	unit_template_bombers = unit_template
	conquests_unitTemplateSetAir(unit_template, 8, 0, bombers_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, bombers_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 25, 500)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")

unit_template = conquests_addNewUnitTemplate("Jet Fighters", 800, "Rocketry", 0, 0, 1)
	conquests_unitTemplateSetAir(unit_template, 0, 24, jet_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, jet_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 0, 0)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")
	conquests_buildableSetReplacedBy(unit_template_fighters, unit_template)

unit_template = conquests_addNewUnitTemplate("Jet Bombers", 1600, "Rocketry", 0, 0, 1)
	conquests_unitTemplateSetAir(unit_template, 24, 0, jet_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, jet_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 33, 2000)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")
	conquests_buildableSetReplacedBy(unit_template_bombers, unit_template)

unit_template = conquests_addNewUnitTemplate("Stealth Bombers", 2400, "Stealth", 0, 0, 1)
	conquests_unitTemplateSetAir(unit_template, 36, 0, jet_travel_range_c, false)
	conquests_unitTemplateSetVisibilityRange(unit_template, jet_travel_range_c)
	conquests_unitTemplateSetBombard(unit_template, 33, 2000)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")

unit_template = conquests_addNewUnitTemplate("Cruise Missile", 200, "Rocketry", 0, 0, 1)
	conquests_unitTemplateSetAir(unit_template, 0, 0, 30, true)
	conquests_unitTemplateSetVisibilityRange(unit_template, 0)
	conquests_unitTemplateSetBombard(unit_template, 50, 2000)
	conquests_buildableSetRequiresImprovement(unit_template, "Missile Launcher")

unit_template = conquests_addNewUnitTemplate("Fission Bomb", 800, "Fission", 0, 0, 1)
	unit_template_fission_bomb = unit_template
	conquests_unitTemplateSetAir(unit_template, 0, 0, bombers_travel_range_c, true)
	conquests_unitTemplateSetVisibilityRange(unit_template, 0)
	conquests_unitTemplateSetNuclearType(unit_template, NUCLEARTYPE_FISSION)
	conquests_buildableSetRequiresImprovement(unit_template, "Airport")

unit_template = conquests_addNewUnitTemplate("Nuclear Missile", 1200, "Nuclear Missiles", 0, 0, 1)
	conquests_unitTemplateSetAir(unit_template, 0, 0, 100, true)
	conquests_unitTemplateSetVisibilityRange(unit_template, 0)
	conquests_unitTemplateSetNuclearType(unit_template, NUCLEARTYPE_FUSION)
	conquests_buildableSetRequiresImprovement(unit_template, "Missile Launcher")
	conquests_buildableSetReplacedBy(unit_template_fission_bomb, unit_template)

-- sea units

unit_template = conquests_addNewUnitTemplate("Galleons", 120, "Magnetism", 0, 0, 1)
	unit_template_galleons = unit_template
	conquests_unitTemplateSetSea(unit_template, 1, 2)
	conquests_buildableSetRequiresImprovement(unit_template, "Port")

unit_template = conquests_addNewUnitTemplate("Ironclads", 300, "Steam Power", 0, 0, 1)
	unit_template_ironclads = unit_template
	conquests_unitTemplateSetSea(unit_template, 8, 4)
	conquests_buildableSetRequiresImprovement(unit_template, "Port")
	-- n.b., don't replace Galleons - still has advantage of being a cheap unit for player to build, compared with Ironclads.

unit_template = conquests_addNewUnitTemplate("Dreadnoughts", 600, "Explosives", 0, 0, 1)
	unit_template_dreadnoughts = unit_template
	conquests_unitTemplateSetSea(unit_template, 16, 5)
	conquests_buildableSetRequiresImprovement(unit_template, "Port")
	conquests_buildableSetReplacedBy(unit_template_galleons, unit_template)
	conquests_buildableSetReplacedBy(unit_template_ironclads, unit_template)

unit_template = conquests_addNewUnitTemplate("Battleships", 1200, "Rocketry", 0, 0, 1)
	conquests_unitTemplateSetSea(unit_template, 24, 6)
	conquests_buildableSetRequiresImprovement(unit_template, "Port")
	conquests_buildableSetReplacedBy(unit_template_dreadnoughts, unit_template)

--[[
unit_template = conquests_addNewUnitTemplate("", 20, "", 0, 0, 1)
	conquests_buildableSetInfo(unit_template, "")
	conquests_unitTemplateSet(unit_template, )
--]]

print("generate_buildables.lua exit")
